
; ***********************************************************************
; *									*
; *	Ensemble des macros necessaires a la gestion de la memoire	*
; *									*
; ***********************************************************************

; Internal data variables
data_offset	set	0
data_a6_offset	set	0
internal_data	set	1

; Set one data :
;	rs name,data_len

rs	MACRO
	ifeq	internal_data
\1	EQU	data_offset
data_offset	set	data_offset+\2
	endif
	ifne	internal_data
\1	EQU	data_a6_offset
data_a6_offset	set	data_a6_offset+\2
	endif
	ENDM

; Ajoute au compteur mais ne declare pas de variables
rs_no	MACRO
	ifeq	internal_data
data_offset	set	data_offset+\2
	endif
	ifne	internal_data
data_a6_offset	set	data_a6_offset+\2
	endif
	ENDM

; Make a synonimous
rs_sym	MACRO
	ifeq	internal_data
\1	EQU	data_offset
	endif
	ifne	internal_data
\1	EQU	data_a6_offset
	endif
	ENDM



; New data (Global data !)
NEW_DATA	MACRO
internal_data	set	1
		ENDM

; struct macros
NEW_STRUCT	MACRO			; Declaration d'une nouvelle structure
internal_data	set	0
data_offset	set	0
		ENDM
SAVE_STRUCT	MACRO			; Sauvegarde de la strucuture
\1		set	data_offset
		ENDM
MULTI_STRUCT	MACRO			; Declaration de structure ayant un parent commun
internal_data	set	0
data_offset	set	\1
		ENDM
END_STRUCT	MACRO			; Fin de la strucuture
\1		set	data_offset
		ENDM

; Exemple : declaration de deux structures  Point et lignes :
; NEW_STRUCT
; rs x,2
; rs y,2
; END_STRUCT coord_struct ; Sauvegarde de la structure parente

; MULTI_STRUCT coord_struct ; Rappel parent
; rs couleur,2
; END_STRUCT point_struct

; MULTI_STRUCT coord_struct
; rs x2,2
; rs y2,2
; END_STRUCT line_struct

; Allocate memory on the stack and make a6 point to this area
; it looks like a lot to link a6,#-..., but I prefer using 6(a6) rather than -6(a6)...
; Example : ALLOCATE_MEM a6
ALLOCATE_MEM	MACRO
	lea	-data_a6_offset(a7),a7
	move.l	a7,a6
		ENDM

; Desallocate memory
DALLOCATE_MEM	MACRO
	lea	data_a6_offset(a6),a7
		ENDM

; Macro for debug usage
; Ex :
; debug <move.w d0,(a0)+>
debug	macro
	ifne	DEBUG
 \1
	endif
	endm
