; Module 'Fight'
; Gestion des combats...
; En fait, cela n'offre qu'un ensemble de routines permettant aux autres modules
; (Module script / Module IA) de communiquer ensemble.
; L'ensemble de la communication est nomme 'Gestionnaire d'attaque'

; Liste des fonctions
;	fight::init
;	fight::quit
;	fight::start
;	fight::attack::check
;	fight::attack::add
;	fight::attack::attack
;	fight::deref
;	


; Demarre un combat sur la carte courante
; In:
;	Nothing
; Out:
;	d0.b = Resultat
; Destroy:
;	d0
fight::start:
	movem.l	d1-d7/a0-a5,-(a7)
	
	movem.l	(a7)+,d1-d7/a0-a5
	rts

; Verifie qu'un personnage peut effectuer une attaque
; In:
;	d0.b = Numero du perso
;	d1.b = Numero du groupe
;	d2.w = Numero de l'attaque
; Out:
;	d1.b = vrai/faux
fight::attack::check:
	

; Ajoute l'attaque de ce perso
; In:
;	d0.b = Numero du perso
;	d1.b = Numero du groupe
;	d2.w = Numero de l'attaque
; Out:
;	d1.b = vrai/faux
fight::attack::add:


error_rts:
	rts

; Effectue l'attaque (enleve les HP).
; In:
;	a0.l -> plf du perso source
;	a1.l -> plf du perso dest
;	d1.w = Type de l'attaque (ATT_FIXE, ATT_VAR, ATT_PHYS, ATT_FIRE... ATT_SPIRIT)
;	d0.w = Force de l'attaque
; Out:
;	d0.l = HP down (>0 si les HP descendent)
; Destroy:
;	d0/d1
fight::attack::attack
	cmp.w	#ATT_MAX,d1
	bhi.s	error_rts
	add.w	d1,d1
	move.w	\attack_table(Pc,d1.w),d1
	jmp	\attack_table(Pc,d1.w)
\attack_table:
	dc.w	att_fix-\attack_table
	dc.w	att_var-\attack_table
	dc.w	att_phy-\attack_table
	dc.w	att_fir-\attack_table
	dc.w	att_wat-\attack_table
	dc.w	att_sha-\attack_table
	dc.w	att_lig-\attack_table
	dc.w	att_spi-\attack_table
att_fix	ext.l	d0
	bra	att_dec_HP
att_var	muls.w	plf_esp_att(a0),d0
	bra	att_dec_HP
att_phy	moveq	#0,d1
	move.b	plf_phy_att(a0),d1
	add.w	d1,d0
	move.b	plf_phy_def(a1),d1
	sub.w	d1,d0
	bra.s	att_dec_hurt
att_fir	moveq	#0,d1
	move.b	plf_feu_att(a0),d1
	add.w	d1,d0
	move.b	plf_feu_def(a1),d1
	sub.w	d1,d0
	bra.s	att_dec_hurt
att_wat	moveq	#0,d1
	move.b	plf_eau_att(a0),d1
	add.w	d1,d0
	move.b	plf_eau_def(a1),d1
	sub.w	d1,d0
	bra.s	att_dec_hurt
att_sha	moveq	#0,d1
	move.b	plf_omb_att(a0),d1
	add.w	d1,d0
	move.b	plf_omb_def(a1),d1
	sub.w	d1,d0
	bra.s	att_dec_hurt
att_lig	moveq	#0,d1
	move.b	plf_lum_att(a0),d1
	add.w	d1,d0
	move.b	plf_lum_def(a1),d1
	sub.w	d1,d0
	bra.s	att_dec_hurt
att_spi	moveq	#0,d1
	move.b	plf_esp_att(a0),d1
	add.w	d1,d0
	move.b	plf_esp_def(a1),d1
	sub.w	d1,d0
	;bra.s	att_dec_hurt

; Inflige un coup de force relative d0.w avec une def de d1.b
att_dec_hurt
	cmp.b	#255,d1		; Test hyper defense ?
	bne.s	\normal_defense
		muls.w	d0,d0
		neg.l	d0
		bra.s	att_dec_HP
\normal_defense:
	; Calcul decrement
	muls.w	d0,d0
	move.l	d0,d1
	
	; Test Hit
	moveq	#127,d0
	bsr	random
	cmp.b	plf_luck(a0),d0
	bhi.s	\no_hit
		add.l	d1,d1
\no_hit:
	; Petit bonus de 12%
	move.l	d1,d0
	bsr	random
	lsr.w	#3,d0
	add.l	d1,d0
	; Gestion limite Dlim = DHp * LimMax / Hpmax
	
	; Gestion contre (phase3) : si phase 3(dest), d1.l = d1.l *2
	
; Decremente l'HP de d0.l
att_dec_HP:
	move.l	plf_HP(a1),d1
	sub.l	d0,d1
	tst.l	d0
	bge.s	\pos
		; Negatif...
		cmp.l	plf_HP_MAX(a1),d1
		ble.s	\end
			move.l	plf_HP_MAX(a1),d1
			bra.s	\end
\pos:	;Positif : on dec l'HP
	tst.l	d1
	bge.s	\end
		moveq	#0,d1
\end:	move.l	d1,plf_HP(a1)
	rts

; Dereference un numero de perso / numero de groupe
; En son adresse plf.
; In:
;	d0.b = Numero du perso
;	d1.b = Numero du groupe
; Out:
;	a0.l -> plf_struct
; Destroy:
;	a0
fight::deref:
	; Lecture des donnes du groupe
	move.l	GRPF1_adr(a6),a0
	tst.b	d1
	beq.s	\Ok
		move.l	GRPF2_adr(a6),a0
\Ok:	
	move.w	d0,-(a7)
	ext.w	d0
	mulu.w	#PF_struct,d0
	lea	GRPF_pf_tab(a0,d0.l),a0
	move.w	(a7)+,d0
	rts

; Dereference un personnage en sa plf struct
; In:
;	d0.b = A.I.N. courant
;	d2.b = Numero demande
; Out:
;	a0.l -> plf_struct
fight::deref::source:
	; Determine le groupe
	move.l	GRPF1_adr(a6),a1
	tst.b	d0
	bge.s	\ok
		move.l	GRPF2_adr(a6),a1
\ok:	; Determine la source principale
	and.w	#%01111,d0
	mulu.w	#PF_struct,d0
	lea	GRPF_pf_tab(a1,d0.l),a0
	
	; Determine quelles sources on demande
	
fight::deref::dest:
fight::deref::ennemies:
