; Module 'console'
; Entre le differents codes du jeu.

; Affiche une chaine de caractere a l'endroit courant sur l'ecran
; Scrolle si necessaire.
; Input : a0 -> String
console::print:
	movem.l	d0-d2/a1,-(a7)
	move.w	Current_y(a6),d1
	moveq	#4,d2
	add.w	#10,d1
	cmp.w	#LCD_HEIGHT-10,d1
	blt.s	\ok
		move.l	#LCD_MEM,a1
		move.w	#960-30*10/4-1,d0
\Loop:			move.l	30*10(a1),(a1)+
			dbra	d0,\Loop
		move.w	#30*10/4-1,d0
\loop2:			clr.l	(a1)+
			dbra	d0,\loop2
		move.w	#LCD_HEIGHT-10,d1
;		bra.s	\print
\ok:	move.w	d1,Current_y(a6)
\print:
	moveq	#0,d0
	bsr	Display_string
	movem.l	(a7)+,d0-d2/a1
	rts


console::enter:
	movem.l	d0-d7/a0-a6,-(a7)
	
	; Reset interrupt
	moveq	#0,d0
	trap	#1

	; Rebascule l'ecran
	clr.w	Current_y(a6)
	bsr	Clear_LCD_MEM
	jsr	genlib::set_LCD_MEM
	lea	_comment(Pc),a0
	bsr	console::print

	; Boucle principale
console_loop:
	; Demande commande
	lea	console_str(pc),a0
	bsr	console::print
	moveq	#16,d1
	move.w	Current_y(a6),d2
	moveq	#32,d3
	bsr	InputStr
	; Dereference la commande
	move.l	a0,a1	; Sauve pointeur
	lea	console_tab(pc),a2
\loop:		move.w	(a2)+,d0
		beq.s	\bad_command
		lea	console_tab(pc,d0.w),a3
		move.l	a1,a0
\cmp:			tst.b	(a3)
			beq.s	\found
			cmpm.b	(a3)+,(a0)+	
			beq.s	\cmp
		; Suivant
		addq.l	#2,a2
		bra.s	\loop
\bad_command:
	lea	bad_command_str(pc),a0
	bsr	console::print
	bra.s	console_loop
\found:	addq.l	#1,a0
;\w	bra.s	\w
	move.w	(a2),d0
	jmp	console_tab(pc,d0.w)
	
	; In: a0 -> Fin de la chaine
console_tab:
commande_tab:
	dc.w	cquit_str-commande_tab,cquit_func-commande_tab
	dc.w	ccont_str-commande_tab,ccont_func-commande_tab
	dc.w	chelp_str-commande_tab,chelp_func-commande_tab
	dc.w	cmap_str-commande_tab,cmap_func-commande_tab
	dc.w	csetx_str-commande_tab,csetx_func-commande_tab
	dc.w	csety_str-commande_tab,csety_func-commande_tab
	dc.w	cgetxy_str-commande_tab,cgetxy_func-commande_tab
	dc.w	0

cquit_func
	illegal	; Methode brutale pour quitter ;)
	
ccont_func
	move.w	#$400,d0
	trap	#1
	movem.l	(a7)+,d0-d7/a0-a6
	rts
	
chelp_func
	lea	commande_tab(Pc),a1
	move.l	a1,a2
\loop		move.w	(a1),d0
		beq	console_loop
		lea	0(a2,d0.w),a0
		bsr	console::print
		addq.l	#4,a1
		bra.s	\loop
		
cmap_func:
	moveq	#16,d0
	moveq	#16,d1
	bsr	game::select_map
	move.w	#$400,d0
	trap	#1
	movem.l	(a7)+,d0-d7/a0-a6
	addq.l	#4,a7
	rts
	
csetx_func:
	bsr	strtonbr
	move.l	Main_adr(a6),a0
	move.w	d0,X(a0)
	bra	console_loop
	
csety_func:
	bsr	strtonbr
	move.l	Main_adr(a6),a0
	move.w	d0,Y(a0)
	bra	console_loop

cgetxy_func:
	lea	console_str(pc),a0
	bsr	console::print
	move.l	Main_adr(a6),a0
	move.w	X(a0),d2
	moveq	#0,d3
	move.w	Current_y(a6),d4
	moveq	#4,d1
	bsr	put_number
	move.w	Y(a0),d2
	moveq	#8*6,d3
	bsr	put_number
	bra	console_loop
	
cgetxy_str	dc.b	"getxy",0
cquit_str	dc.b	"quit",0
ccont_str	dc.b	"cont",0
chelp_str	dc.b	"help",0
cmap_str	dc.b	"map",0
csetx_str	dc.b	"setx",0
csety_str	dc.b	"sety",0
console_str	dc.b	">",0
bad_command_str	dc.b	"Bad command",0
	EVEN
	