; Module 'Dialog'
; Ensemble des fonctions necessaires pour gerer les dialogues.

; Liste des fonctions :
;	dialog::init
;	dialog::quit
;	dialog::message
;	dialog::put_box
;	dialog::do

ENTER			EQU		$8
LEFT			EQU		$4
RIGHT			EQU		$6
UP			EQU		$5
DOWN			EQU		$7

flib::zap_screen	EQU		Clear_LCD_MEM
flib::idle_loop		EQU		GetKey

	ifd	ti89
XSCREEN			EQU		20
YSCREEN			EQU		100
	endif

	ifnd	ti89
XSCREEN			EQU		30
YSCREEN			EQU		128
	endif


	IFD ti92
ti_small			EQU		tios::SF_font+$1
ti_medium			EQU		tios::SF_font+$600
ti_large			EQU		tios::SF_font+$E00
	ENDIF

	IFND ti92
ti_small			EQU		tios::font_small+$1
ti_medium			EQU		tios::font_medium
ti_large			EQU		tios::font_large
	endif

ecran1		dc.l	0
ecran2		dc.l	0

	include		"Chroninc\Code\PutBox.h"
	include		"Chroninc\Code\Main.h"
;	include		"Chroninc\Graph\Box.gfx"
	include		"Chroninc\Equ.h"
	EVEN

; Initalise la session de dialogue

dialog::init:
	movem.l	d0-d7/a0-a6,-(a7)

; ***********************************************************************
; Initialisation OBLIGATOIRE des diffrentes fontes
; ***********************************************************************

	Create_NewFont	small,#ti_small,correction_small,#4,#6
	Create_NewFont	medium,#ti_medium,correction_nulle,#6,#8
	Create_NewFont	large,#ti_large,correction_nulle,#8,#10

; ***********************************************************************
; Chargement d'une session de dialogue + Table des noms
; ***********************************************************************

	lea			NameTable(Pc),a0		; Chargement des raccourcis de noms
	lea			Crono_p(Pc),a1
	move.l			a1,(a0)+
	lea			Lucca_p(Pc),a1
	move.l			a1,(a0)+
	lea			Marle_p(Pc),a1
	move.l			a1,(a0)+
	lea			Frog_p(Pc),a1
	move.l			a1,(a0)+
	lea			Robo_p(Pc),a1
	move.l			a1,(a0)+
	lea			Ayla_p(Pc),a1
	move.l			a1,(a0)+
	lea			Magus_p(Pc),a1
	move.l			a1,(a0)+

	lea			ImageTable(Pc),a0	; Chargement des raccourcis d'images
	lea			Crono_i(pc),a1
	move.l			a1,(a0)+
	lea			Lucca_i(pc),a1
	move.l			a1,(a0)+
	lea			Marle_i(pc),a1
	move.l			a1,(a0)+
	lea			Frog_i(pc),a1
	move.l			a1,(a0)+
	lea			Robo_i(pc),a1
	move.l			a1,(a0)+
	lea			Ayla_i(pc),a1
	move.l			a1,(a0)+
	lea			Magus_i(pc),a1
	move.l			a1,(a0)+
	lea			Buffer_Pic(pc),a1
	move.l			a1,(a0)+

	lea			DialogTable(pc),a0	; Chargement des raccourcis de dialogue
	lea			YesNo_Dial(pc),a1
	move.l			a1,(a0)+

	movem.l	(a7)+,d0-d7/a0-a6
	rts

dialog::quit:
	rts

; Print message
; Create a small dialog struct to show this text.
; In : a0 -> String
; out : nothing.
; Destroy : nothing.
dialog::message:
	movem.l	a0-a1,-(a7)
	lea	Free_buffer(a6),a1
	move.b	#SetDialog,(a1)+
	move.b	#PutBox,(a1)+
	move.b	#1,(a1)+
	move.b	#ChangeFont,(a1)+
	move.b	#Large,(a1)+
	move.b	#ChangeColor,(a1)+
	move.b	#Black,(a1)+
	move.b	#CenterText,(a1)+
\loop:		move.b	(a0)+,(a1)+
		bne.s	\loop
	move.b	#WaitKey,-1(a1)
	move.b	#EndDialog,(a1)

	lea	Free_buffer(a6),a0
	bsr.s	dialog::do
	movem.l	(a7)+,a0-a1
	rts


; Affiche une boite de dialogue.
; Stoppe tous les processus pendant l'affichage.
; In  : A0 -> Dialog struct
; Out : Update the status of the player if needed.
; Destroy : nothing.
dialog::do
	movem.l	d0-d7/a0-a6,-(a7)

	move.w	Select_s(a6),d1		; Read temps
	eor.w	#4,d1
	move.l	Screen_1(a6,d1.w),a1	; Read a screen
	lea	SCREEN_SIZE(a1),a2
	move.l	a2,ecran1
	move.l	a1,ecran2

;	Load_String	a0	; Ca fait con move.l a0,a0
	move.l	a0,P_String
	bsr	StartDialog

	movem.l	(a7)+,d0-d7/a0-a6
	rts

; Data
	include		"Chroninc\Code\Datas.h"
	include		"Chroninc\Script.h"
	include		"Chroninc\D_Script.h"
	EVEN

ImageTable:		; Table des images
	ds.l		8
NameTable:		; Table des personnages
	ds.l		7
DialogTable:		; Table des dialogues
	ds.l		1

