; Module 'error'
; Ensemble des routines utilises en cas d'erreur.
; Utilise le module dialog pour afficher des messages.

;Liste des fonctions
;	error::internal
;	error::memory
;	error::file_invalid
;	error::file_not_found
;	error::too_many_stories
;	error::privelege
;	error::cant_find_player
;	error::illegal_story
;	error::player_no_member
;	error::type_stack_overflow
;	error::too_many_exe_sprites
;	error::too_many_sprites

error::too_many_sprites:
	lea	too_many_sprites_str(Pc),a0
	bra.s	Display_message

error::too_many_exe_sprites:
	lea	too_many_exe_sprites_str(Pc),a0
	bra.s	Display_message

error::type_stack_overflow:
	lea	type_stack_overflow_str(Pc),a0
	bra.s	Display_message

error::player_no_member:
	lea	player_no_member_str(Pc),a0
	bra.s	Display_message

error::illegal_story:
	lea	illegal_story_str(Pc),a0
	bra.s	Display_message

error::cant_find_player:
	lea	cant_find_player_str(Pc),a0
	bra.s	Display_message

error::privelege:
	lea	local_story_str(Pc),a0
	bra.s	Display_message

error::too_many_stories:
	lea	too_many_stories_str(Pc),a0
	bra.s	Display_message

error::internal:
	lea	internal_error_str(Pc),a0
	bra.s	Display_message

error::memory:
	lea	memory_error_str(Pc),a0
	bra.s	Display_message

; Input : a0 -> String
error::file_invalid:
        move.l	a0,-(a7)		; Push string
	pea	file_invalid_str(pc)	; Push format string
	bra.s	F_disp

; Input : a0 -> String
error::file_not_found:
        move.l	a0,-(a7)		; Push string
	pea	file_not_found_str(pc)	; Push format string
F_disp:	lea	Free_buffer(a6),a4	; A4 -> string buffer
	pea	(a4)			; Push buffer address
	jsr	tios::sprintf		; Write string into buffer
	move.l	a4,a0

; Display a message before quitting.
; Input:
;	a0 -> String
Display_message:
	jsr	genlib::set_LCD_MEM	; Set the auto-int to the LCD_MEM
;	pea	(1).w			; Bouton right = none / Left = Ok
;	move.l	a0,-(a7)
;	pea	fatal_error_str(Pc)
;	move.l	a6,a5
;	lea	tios::DlgMessage,a6
;	jsr	genlib::use_int1
;	move.l	a5,a6
	move.l	a0,-(a7)
	jsr	tios::ST_showHelp
	jsr	genlib::wait_a_key
	bra	_quit

fatal_error_str:
	dc.b "!! FATAL ERROR !!",0
file_invalid_str:
	dc.b "File %s invalid !",0
file_not_found_str:
	dc.b "File %s not found !",0
memory_error_str:
	dc.b "Memory overflow !",0
internal_error_str:
	dc.b "Internal error !",0
too_many_stories_str:
	dc.b "EVENT : Too many !",0
local_story_str:
	dc.b "EVENT : Privelege violation !",0
cant_find_player_str:
	dc.b "EVENT : Can't find player !",0
illegal_story_str:
	dc.b "EVENT : Illegal opcode !",0
player_no_member_str:
	dc.b "Player isn't member !",0
type_stack_overflow_str:
	dc.b "Type_stack overflow !",0
too_many_exe_sprites_str:
	dc.b "Too many exe sprites !",0
too_many_sprites_str:
	dc.b "Too many sprites !",0
	EVEN		; Alignement des donnes
