; Module header de 'Fight'
; Gestion des combats...
; En fait, cela n'offre qu'un ensemble de routines permettant aux autres modules
; (Module script / Module Groupe / Module IA) de communiquer ensemble.
; L'ensemble de la communication est nomme 'Gestionnaire d'attaque'

; Definition des differents etats d'un perso en cours d'une bataille
PF_MORT		EQU	0
PF_REPOS	EQU	1
PF_PRET		EQU	2
PF_DEPLACE	EQU	3
PF_ATTAQUE	EQU	4
PF_REVIENT	EQU	5

; Definition des differents etats d'une attaque
AIN_FREE	EQU	0
AIN_PHASE1	EQU	1
AIN_READY	EQU	2
AIN_ATTACK	EQU	3
AIN_PHASE3	EQU	4


; Definition d'un PF possedant une A.I.N
	NEW_STRUCT
	rs	PF_etat,1	; Etat du personnage
	rs	PF_att_no,1	; Numero de l'attaque
	rs	PF_attack,1	; Etat de l'attaque (AIN_FREE, ...)
	rs	PF_grp,1	; Numero de groupe d'attaque commun
	rs	PF_dest_grp,1	; Numero du groupe de destination
	rs	PF_dest_perso,1; Numero du personnage de destination
	rs	PF_plf_adr,4	; Adresse struct plf
	END_STRUCT	PF_struct

; Les attaques sont stockes sont deux formes :
; Les attaques individuelles et les groupees.
; + Les individuelles sont stockes dans un tableau de 256 elements.
;	Un element est une structure du type :
	NEW_STRUCT
	rs	RATT_tech,2	; Experience technique minimale a avoir.
	rs	RATT_mp,1	; MP minimun pour l'attaque
	rs	RATT_dist,1	; Porte maximale entre la source et l'attaque (/16)
	rs	RATT_phase1,2	; Offset par rapport au debut de la struct pour la phase1
	rs	RATT_phase2,2	; Offset par rapport au debut de la struct pour la phase2
	END_STRUCT	RATT_struct
; + Les collectives sont quand a elles stockes sparment :
; Et elles offrent un maximun de quatre en meme temps.
; Primo, on prend le numero des attaques courantes ($40, $10 et $1).
; On les classe par ordre ($1, $10 et $40), et on genere un mot long $00011040)
; en completant avec des 00 au debuts.
; Puis on recherche dans la table de definitions des liens s'il y est.
; Si oui, on va lire l'offset de la phase 2.
; Pb : classement des sprites : les classer dans le meme ordre que l'attaque

; Type des attaques:
ATT_FIXE	EQU	0
ATT_VAR		EQU	1
ATT_PHYS	EQU	2
ATT_FIRE	EQU	3
ATT_WATER	EQU	4
ATT_SHADOW	EQU	5
ATT_LIGHTING	EQU	6
ATT_SPIRIT	EQU	7
ATT_MAX		EQU	7

; Definitions d'un groupe
	MULTI_STRUCT	SPRITE_base
	rs	GRPF_nbr,1			; Nombre de personnage dans le groupe de combat
	rs	GRPF_no,1			; Numero de groupe
	rs	GRPF_pf_tab,PF_struct*16	; Max : 16
	END_STRUCT	SPRITE_grpf		; Attention : ne peut pas se deplacer.

	; Donnes globales
	NEW_DATA
	rs	GRPF1_adr,4
	rs	GRPF2_adr,4
	