; Module Key

; Gestion des touches
'

;Liste des modules:
;	exec_double_buffer
;	exec_key
;	exec_scrolling

exec_keys:
	jsr	genlib::read_joypad	; Read the joypad
	move.l	d0,d2
	move.l	key_mask(a6),d1
	or.l	d1,d0
	move.l	d0,key(a6)
	not.l	d2
	and.l	d2,d1
	move.l	d1,key_mask(a6)
	
	; Test : Esc / + / -
	btst.b	#exit_key,d0		; Test exit key
	bne.s	\no0
		move.b	#_EXIT_MODE,Game_mode(a6)
		rts
\no0:	btst.b	#plus_key,d0
	bne.s	\no1
		moveq	#09,d0	; 9=contrast_up
		trap	#9	; trap
		jsr	(a0)	; call rom
		bset.b	#plus_key,(key_mask+3)(a6)
		bra.s	\end_key
\no1:	btst.b	#minus_key,d0
	bne.s	\no2
		moveq	#10,d0	; 10=contrast_down
		trap	#9
		jsr	(a0)
		bset.b	#minus_key,(key_mask+3)(a6)	
		bra.s	\end_key
\no2:	btst.b	#mode_key,d0
	bne.s	\no3
		trap	#4
\no3:
\end_key:
	addq.l	#4,a3
	move.l	(a3)+,a0
	jmp	(a0)

; Update scrolling data of plane A & B
; Destroy : d0-d2 / a0-a2
exec_scrolling:
	move.l	Main_adr(a6),a0		; Main character IS the 1st sprite
	move.w	X(a0),d0		; Pas tres beau
	move.w	Y(a0),d1		; Non, vraiment pas...

	sub.w	Center_x(a6),d0
	sub.w	Center_y(a6),d1
	
	move.l	Plan_A_adr(a6),a0

	move.w	xmin(a6),d2
	cmp.w	d2,d0
	ble.s	\esc
		move.w	xmax(a6),d2
		cmp.w	d2,d0
		bge.s	\esc
			move.w	d0,d2
\esc:	move.w	d2,PLANE_XS(a0)

	move.w	ymin(a6),d2
	cmp.w	d2,d1
	ble.s	\esc2
		move.w	ymax(a6),d2
		cmp.w	d2,d1
		bge.s	\esc2
			move.w	d1,d2
\esc2:	move.w	d2,PLANE_YS(a0)

	tst.b	Calc_B(a6)		; If special_effect
	bne.s	\no_calc		; Do not calculate the coordinate !

		move.l	Plan_B_adr(a6),a1
		move.l	Map_adr(a6),a2

		move.w	PLANE_XS(a0),d0
		move.b	d7,d1
		sub.b	map_size2_x(a2),d1
		ble.s	\nn1
		lsr.w	d1,d0
		bra.s	\dd1
\nn1:		neg.w	d1
		lsl.w	d1,d0
\dd1:		move.w	d0,PLANE_XS(a1)
		
		move.w	PLANE_YS(a0),d0
		move.b	Diff_y(a6),d1
		ble.s	\nn2
		lsr.w	d1,d0
		bra.s	\dd2
\nn2:		neg.w	d1
		lsl.w	d1,d0
\dd2:		move.w	d0,PLANE_YS(a1)
\no_calc:
	addq.l	#4,a3
	move.l	(a3)+,a0
	jmp	(a0)


; Update the double-buffer.
; And inc the time
; In      : nothing
; Out     : nothing
; Destroy : d0-d1
Wait_next_frame:
	movem.l	d0-d1/a3,-(a7)
	pea	\suite(Pc)
	clr.l	-(a7)
	move.l	a7,a3
	bra.s	exec_double_buffer
\suite:	addq.l	#8,a7
	movem.l	(a7)+,d0-d1/a3
	rts

exec_double_buffer:
	move.w	Select_s(a6),d1		; Read temps
	move.l	Screen_1(a6,d1.w),d0	; Read a screen
	jsr	genlib::set_dscreen_int	; Set the interrupt to this Dscreen
	eor.w	#4,d1			; Next screen
	move.l	Screen_1(a6,d1.w),d0	; Read the other screen
	move.l	d0,Current_dscreen(a6)	; Save it.
	jsr	genlib::set_dscreen_function	; Set the functions to this DScreen
	move.w	d1,Select_s(a6)		; Save temps

\wait:		cmp.l	#6-1,genlib::timer
		bls.s	\wait			; 15 Hz waiting
	clr.l	genlib::timer

	; Le temps s'ecoule
	swap	d7
	addq.w	#1,d7			; Next time (Fast way)
	swap	d7
	addq.l	#1,Time(a6)		; Le temps ecoule depuis le debut

	addq.l	#4,a3
	move.l	(a3)+,a0
	jmp	(a0)

