; Module de math 
; Differentes routines

; Calcul de la racine carre.
; In:
;	d0.l = Int
;	But only the lowest 17 bit are available
; Out:
;	d1.w = Sqrt(Int)
; Use: Un+1 = 1/2 (Un + a / Un)
math::sqrt:
	move.l	d2,-(a7)

	move.l	d0,d1
	beq.s	\zero
		lsr.l	#1,d1
		beq.s	\one
		
		move.w	d1,d2
\loop			move.w	d2,d1
			move.l	d0,d2
			divu	d1,d2
			add.w	d1,d2
			lsr.w	#1,d2
			cmp.w	d1,d2
			bne.s	\loop
\zero:
	move.l	(a7)+,d2
	rts
\one:
	moveq	#1,d1
	bra.s	\zero

;Calcul de la puissance
; In:
;	d0.w = Nombre
;	d1.w = Exposant
; Out:
;	d0.w = Nombre ^ Exposant
; Destroy
;	d1.w
math::pow
	cmp.w	#1,d1
	bls.s	\done

	btst.l	#0,d1
	beq.s	\pow2

		move.w	d0,-(a7)
		lsr.w	#1,d1
		bsr.s	math::pow
		mulu.w	d0,d0
		mulu.w	(a7)+,d0
		bra.s	\done
\pow2	mulu.w	d0,d0
	lsr.w	#1,d1
	bra.s	math::pow

\done:	tst.w	d1
	bne.s	\ret
		moveq	#1,d0
\ret	rts

