; Afficheur de messages
;
; Affiche un message en parallele pendant un certain temps, puis il disparait

; Description :
	MULTI_STRUCT	SPRITE_base
	rs	ms_cpt,2
	rs	ms_offset,2
	rs	ms_sizex,2
	rs	ms_sizey,2
	rs	ms_font,2
	END_STRUCT	SPRITE_message

; Call:
;	d3.w = Nbr_seconde * 15
;	d4.w = Font (0 ou -1)
;	a4 -> Boite

init_message:
	move.w	d3,ms_cpt(a5)
	move.w	d4,ms_font(a5)

	; Calcul offset
	clr.w	d0
	move.b	(a4)+,d0	; X
	clr.w	d1
	move.b	(a4)+,d1	; Y

	add.w	d1,d1
	move.w	d1,d2
	lsl.w	#4,d1
	sub.w	d2,d1		; Y *30

	lsr.w	#4,d0		; X / 16
	add.w	d0,d0		; 2* E(X/16)
	add.w	d0,d1

	move.w	d1,ms_offset(a5)

	; Calcul pointeur dans window
	move.l	genlib::window,a1
	lea	0(a1,d1.w),a0

	; Lecture taille
	clr.w	d0
	move.b	(a4)+,d0
	clr.w	d1
	move.b	(a4)+,d1

	; Correction Sx & Sy
	subq.w	#1,d0
	lsr.w	#4,d0			; D0.w = Arrondi_exec(Sx / 16)
	move.w	d0,ms_sizex(a5)

	subq.w	#1,d1
	move.w	d1,ms_sizey(a5)

	; Calcul saut de ligne
	moveq	#15,d2			; 30 bytes is a line
	sub.w	d0,d2
	subq.w	#1,d2			; A cause du dbf
	add.w	d2,d2

	; Affichage boite
	moveq	#-1,d4
	moveq	#-1,d5
	moveq	#-1,d6
	bsr.s	Draw_box_line
	move.w	#%1000000000000000,d4
	moveq	#0,d5
	moveq	#3,d6
	bsr.s	Draw_box_line
	move.w	#%1011111111111111,d4
	moveq	#-1,d5
	moveq	#-1,d6
	bsr.s	Draw_box_line

	subq.w	#6,d1
	blt.s	\done
\loopy:
		move.w	#%1010000000000000,d4
		moveq	#0,d5
		moveq	#%0000000000000111,d6
		bsr.s	Draw_box_line
		dbf	d1,\loopy
\done:
	move.w	#%1011111111111111,d4
	moveq	#-1,d5
	move.w	#%1111111111111111,d6
	bsr.s	Draw_box_line
	moveq	#-1,d4
	moveq	#-1,d5
	moveq	#-1,d6
	bsr.s	Draw_box_line
	moveq	#-1,d4
	moveq	#-1,d5
	moveq	#-1,d6
	bsr.s	Draw_box_line

	; Affichage texte
	; Relecture x pos / y pos
	clr.w	d2
	move.b	-4(a4),d2
	clr.w	d3
	move.b	-3(a4),d3
\loop
		clr.w	d0
		move.b	(a4)+,d0
		cmp.b	#$FF,d0
		beq.s	\fin
		clr.w	d1
		move.b	(a4)+,d1

		add.w	d2,d0		; De relatif a absolu
		add.w	d3,d1		
		move.l	a4,a0		; a0 -> Chaine
		jsr	genlib::put_large_string

		; Recherche 0
\wait:			tst.b	(a4)+
			bne.s	\wait
		bra.s	\loop
\fin:	rts

; In:
;	a0 -> Window + offset
;	d0.w = Nbr de mot
;	d2.w = Offset pour ligne suivante
;	d3.w = destroyed  !
;	d4.w = Debut a remplir
;	d5.w = Continue
;	d6.w = Fin a remplir
Draw_box_line:
	move.w	d0,d3

	move.w	d4,(a0)+
	subq.w	#2,d3
	blt.s	\fin
\loop:
		move.w	d5,(a0)+
		dbf	d3,\loop
\fin	move.w	d6,(a0)+
	adda.w	d2,a0
	rts

exec_message:
	move.l	(a3)+,a5

	; Gestion
	subq.w	#1,ms_cpt(a5)
	beq	sprite::next

	; Calcul pointeur sur ecrans
	move.w	ms_offset(a5),d0
	move.l	genlib::window,a0
	adda.w	d0,a0
	move.l	Current_dscreen(a6),a1
	adda.w	d0,a1
	lea	SCREEN_SIZE(a1),a2

	; Calcul saut de ligne
	moveq	#15,d0			; 30 bytes is a line
	sub.w	ms_sizex(a5),d0
	subq.w	#1,d0			; A cause du dbf
	add.w	d0,d0

	; Lecture masque de font
	move.w	ms_font(a5),d3

	; Affichage
	move.w	ms_sizey(a5),d1
\loopy:		move.w	ms_sizex(a5),d2
\loopx:			
			move.w	d3,(a2)+
			move.w	(a0)+,(a1)+
			dbf	d2,\loopx
		adda.w	d0,a0
		adda.w	d0,a1
		adda.w	d0,a2
		dbf	d1,\loopy

	; Sprite suivant
	move.l	(a3)+,a0
	jmp	(a0)
