; Module 'Object'
; Gestion des objets (Ajout / enleve / modification des donnes RAM).

; A refaire car modification des structures !!!!!!
; Afin d'utiliser - de mem

; Liste des fonctions:
;	object::init
;	object::quit
;	object::add
;	object::is
;	object::deref
;	object::use
;	object::use_remove
;	object::remove

;	object::calculate
;	object::save
;	object::load

; Initialise le module objets.
; A appeler avant toute utilisation d'une quelconque fonction de ce module
; (Appeler automatiquement lors de la creation d'un jeu, donc en cours du jeu
; c'est inutile)
; Quitte si erreur
; In:	nothing
; Out:	nothing
; Destroy:
;	D0-d2 / a0 - a1
object::init:
	moveq	#(MAX_OBJECT),d0
	bsr	Alloc
	move.w	d0,Object_hd
	move.l	a0,Object_adr(a6)
	move.w	#(MAX_OBJECT-1),d0
\clr_loop:	clr.b	(a0)+
		dbf	d0,\clr_loop
	rts

Object_hd	dc.w	0

; Libere tout du module 'objets'
; A appeler lors de la fin du jeu.
; In / Out / Destroy : nothing
object::quit:
	move.w	Object_hd(Pc),d0
	bra	Free

; Ajoute un objet a la pile des objets possedes par les persos courants.
; In  :
;	D0.w = Object
; Out : Nothing
; Destroy : nothing
object::add
	move.l	a0,-(a7)
	move.l	Object_adr(a6),a0
	cmp.w	#MAX_OBJECT-1,d0
	bhi.s	\Out_of_range
		addq.b	#1,0(a0,d0.w)
\Out_of_range:
	move.l	(a7)+,a0
	rts

; Recherche un objet dans la ROM et retourne son adresse dans la ROM
; In  : d0.w = Object
; Out : A0.l -> Rom_object or NULL
; Destroy : nothing
object::deref:
	move.l	d0,-(a7)
	suba.l	a0,a0
	cmp.w	#MAX_OBJECT-1,d0
	bhi.s	\found
		mulu	#object_rom_size,d0
		move.l	ROM_Object_tab(a6),a0
		adda.l	d0,a0
\found:	move.l	(a7)+,d0
	rts

; Test si les joueurs possedent l'objet d0.w
; In : D0.w = Type de l'objet
; Out:
;	d2.b = 0 si l'objet n'est pas en possesion
;	d2.b <> 0 sinon.
;	Update the flag
; Destroy : a0
object::is
	clr.b	d2
	move.l	Object_adr(a6),a0
	cmp.w	#MAX_OBJECT-1,d0
	bhi.s	\no
		move.b	0(a0,d0.w),d2
\no:	rts

; Utilise l'objet d0.
; In :	d0.w : Object
;	a1 -> Destination
;	a2 -> Source
; Out : nothing
; Destroy : Nothing
object::use
	movem.l	d2/a4/a0,-(a7)
	bsr.s	object::is
	beq.s	\cant
		move.l	Object_adr(a6),a0
		adda.w	d0,a0		; A0 -> Object
		move.w	object_rom_meta_data(a0),d2
		lea	0(a0,d2.w),a4
		move.l	a2,a0
;		bsr	use_meta_data
\cant:	movem.l	(a7)+,d2/a4/a0
	rts

; Use and remove the object d0.w
; In :
;	d0.w 
; Out : nothing
; Destroy : nothing.
object::use_remove
	bsr.s	object::use

; Remove the object d0.w
; In  : d0.w
; Out : nothing
; Destroy : nothing
object::remove
	movem.l	d2/a0-a1,-(a7)
	bsr.s	object::is
	beq.s	\end
		subq.b	#1,0(a0,d0.w)	; A0 -> Object_adr grace a is_object
\end:	movem.l	(a7)+,d2/a0-a1
	rts
