; Description des structures 'Player'

; C'est l'un des fichiers include les + importants, si ce n'est le + important
; Il definit l'ensemble des structures des personnages, des animations et des sprites
; bref, il faut l'avoir toujours sous la main pour savoir qui est quoi !


; ***********************************************************************
; *									*
; *	Description d'un sprite de base (non affichable)		*
; *									*
; ***********************************************************************

	NEW_STRUCT
	rs	Type,1		; Type originel du sprite
	rs	Prior,1		; Priorite de gestion
	rs	Type2,1		; Type secondaire du sprite
	rs	Type3,1		; 3em Type du sprite
	rs	Size,2		; Taille de la structure du sprite
	END_STRUCT	SPRITE_base

; ***********************************************************************
; *									*
; *	Description d'un sprite de base (non affichable) avec donnes	*
; *									*
; ***********************************************************************

	MULTI_STRUCT	SPRITE_base
	rs	Extra_data,4
	END_STRUCT	SPRITE_data

; ***********************************************************************
; *									*
; *	Description d'un sprite affichable				*
; *									*
; ***********************************************************************
	MULTI_STRUCT	SPRITE_base
	rs	X,2		; X position of the sprite
	rs	Y,2		; Y position of the sprite
	rs	H,1		; Height (0, 1, 2 or 3)		// Hauteur courante du sprite
	rs	Drawing,1	; Which routine of drawing	// Si c'est 2, alors c'est un player !
	rs	Gfx_adr,4	; Adress of the graph table of the animation struct
	rs	Ani_adr,4	; Adress of the anim table of the animation struct
	rs	Sens,1		; Sens (Up = 0, down = 1, left = 2, right = 3)
	rs	Ani,1		; Current animation (0, 6, ... 6*n)
	rs	Ani_sub,1	; Sub data to calculate the good image (Follow Ani !)
	rs	Ani_cpt,1	; Cpt for calculate the good image
	END_STRUCT	SPRITE_print




; ***********************************************************************
; *									*
; *		Desciption d'un sprite-perso				*
; *									*
; ***********************************************************************

	MULTI_STRUCT	SPRITE_print
	rs	Player_no,2		; Numero du personnage
	rs	Level,2			; Level du personnage
	rs	Diag_adr,4		; Adress of the dialog struct of the player
	rs	Xd,2			; Destination X
	rs	Yd,2			; Destination Y
	SAVE_STRUCT	SPRITE_player	; Player avec rien (non utilisable)




; ***********************************************************************
; *									*
; *		Description des sprite-persos evolues			*
; *									*
; ***********************************************************************

	MULTI_STRUCT	SPRITE_player
	rs	P_action,2		; Type d'action
	rs	P_cpt,2			. Compteur
	END_STRUCT	SPRITE_alea


; ***********************************************************************
; *									*
; *		Description du personnage principal			*
; *									*
; ***********************************************************************

	MULTI_STRUCT	SPRITE_player
	rs	X_old,2
	rs	Y_old,2
	END_STRUCT	SPRITE_main	;	equ	SPRITE_player


; ***********************************************************************
; *									*
; *		Description des personnages qui le suivent		*
; *									*
; ***********************************************************************

	MULTI_STRUCT	SPRITE_player
	rs	Tampon_ptr,2		; Pour pointer vers le tampon
	rs	Tampon,(2+2+1+1)*8
	END_STRUCT	SPRITE_follow







; ***********************************************************************
; *									*
; *		Descripion de la structure du statut du perso		*
; *									*
; ***********************************************************************

	NEW_STRUCT
	rs	ST_HP,4			; HP minimun
	rs	ST_MP,2			; MP minimun
	rs	ST_phy_att,1
	rs	ST_phy_def,1
	rs	ST_feu_att,1
	rs	ST_feu_def,1
	rs	ST_eau_att,1
	rs	ST_eau_def,1
	rs	ST_lum_att,1
	rs	ST_lum_def,1
	rs	ST_omb_att,1
	rs	ST_omb_def,1
	rs	ST_esp_att,1
	rs	ST_esp_def,1
	rs	ST_speed,1
	rs	ST_luck,1
	rs	ST_texp,1		; Valeur minimale de l'experience des techniques /16
	rs	ST_IA_fight,1		; Numero d'I/A a utiliser pour combattre.

	rs	ST_EXP,2
	rs	ST_evol_tab,0
	rs	ST_att_tab,0
	END_STRUCT	statut_struct

; ***********************************************************************
; *									*
; *			Description du personnage en ROM		*
; *									*
; ***********************************************************************
	NEW_STRUCT
	rs	ROM_Player_name,6	;+ Nom du joueur (Crono, Magus, ...)
	rs	ROM_gfx_table,2		; Offset vers la table de graph du perso
	rs	ROM_ani_table,2		; Offset vers la table d'animation.
	rs	ROM_statut,2		; Offset vers la structure d'evolution du statut (=0 si le perso peut pas se battre)
	END_STRUCT	player_rom_struct


; ***********************************************************************
; *									*
; *		Description du personnage en mode combat		*
; *									*
; ***********************************************************************
	NEW_STRUCT
	rs	plf_no,2		; Numero du personnage
	rs	plf_adr,4		; Adresse du sprite perso

	rs	plf_level,2		; Niveau du personnage
	rs	plf_exp,4		; Experience
	rs	plf_texp,2		; Experience technique

	rs	plf_HP,4		; HP
	rs	plf_MP,2		; MP
	rs	plf_HP_MAX,4		; HP max
	rs	plf_MP_MAX,2		; MP max

	rs	plf_phy_att,1		; Puissance physique
	rs	plf_phy_def,1		; Defense physique
	rs	plf_feu_att,1		
	rs	plf_feu_def,1
	rs	plf_eau_att,1
	rs	plf_eau_def,1
	rs	plf_lum_att,1
	rs	plf_lum_def,1
	rs	plf_omb_att,1
	rs	plf_omb_def,1
	rs	plf_esp_att,1
	rs	plf_esp_def,1

	rs	plf_speed,1		; Vitesse
	rs	plf_luck,1		; chance

	rs	plf_wait,1		; Attente
	rs	plf_limit,1		; Limite

	rs	plf_weapon,2		; Arme courante
	rs	plf_helmet,2		; Casque courant
	rs	plf_armor,2		; Armure
	rs	plf_accessory,2		; Accessoire
	END_STRUCT	plf_struct

; ***********************************************************************
; *									*
; *		Description de la table d'animation.			*
; *			d'un perso en ROM				*
; *									*
; ***********************************************************************

; Maximun : 85 animations !

	NEW_STRUCT
ani		MACRO
	rs	\1,3			; Flemmard le monsieur
		ENDM

	ani	ANI_NORMAL		; Debout
	ani	ANI_WALK		; Marcher
			; Fin des animations pour les personnages normaux.
	ani	ANI_START_FIGHT		; Se preparer a la bataille.
	ani	ANI_END_FIGHT		; Finir la bataille.
	ani	ANI_READY_FIGHT		; En attente de frapper.
	ani	ANI_MOVE_HIT		; Se deplacer pour frapper.
	ani	ANI_HIT			; Frapper (probleme positionnement par rapport a la destination du coup).
	ani	ANI_AFTER_HIT		; Revenir apres avoir frapper.
	ani	ANI_INVOKE		; Invoquer un sort
	ani	ANI_LAUNCH		; Lancer un sort.
	ani	ANI_DEAD		; Mort
	ani	ANI_VICTORY		; Victoire.
	ani	ANI_HURT		; Recevoir un coup
	ani	ANI_LOW_LEVEL		; Faible niveau de vie
			; Fin des animations des personnages de bases (Ennemis + autres)
			; Ajout pour les personnages jouables + Extra pour les autres
	ani	ANI_RUN			; Courir
	ani	ANI_TELEPORT		; Teleportation
	ani	ANI_FALL		; Tomber
	ani	ANI_JUMP		; Sauter.
	ani	ANI_CLIMB		; Escalader
	ani	ANI_AFRAID		; Effraye
	ani	ANI_DODO		; Dormir
	ani	ANI_IMAGE		; Image 32x32 du personnage (Et oui c'est une animation, mais c'est pour respecter le standart !)
			; Extra animation ?
	ani	ANI_THINK		; Penser

	ani	ANI_SURPRISE
	ani	ANI_LOOK
	ani	ANI_OK
	ani	ANI_RAGE
	ani	ANI_DANCE

MAX_PLAYER	EQU	20
