; Print screen header file

; ***********************************************************************
; *									*
; *				Constantes				*
; *									*
; ***********************************************************************

MAX_SPRITE_SIZE		EQU	64		; Taille maximale d'un sprite affiche 64x64
MAX_CANI		EQU	48		; Taille du tableau des ani classees (multiple de 8)
FH			EQU	4 		; Horizontal flip
FV			EQU	8 		; Vertical flip

; Constante servant a definir en pixels les differentes hauteurs.
; i.e. si d0 est la hauteur de la case (0,1,2,3) alors d0*2^HGT_PIX est la vrai hauteur
HGT_PIX		EQU	5

; Definition des arguments de Drawing (Animation struct)
NOTHING_DRAW		EQU	0
ANI_BGS_DRAW		EQU	2
BGS_DRAW		EQU	4
ANI_S16_DRAW		EQU	6
S16_DRAW		EQU	8

; Sprite class
	NEW_STRUCT				; Strucutre elementaire d'un sprite classe
	rs	cani_Y,2			; Coordonne Y de l'animation
	rs	cani_adr,4			; Adresse de l'animation
	END_STRUCT	cani_struct_size	; Cette structure ne peut etre modifiee sans modifiee le code !

; Tableau d'images.
	NEW_STRUCT				; Struct elem d'un element d'un tableau de redirection des graphs
	rs	gfx_offset,2			; Offset par rapport au debut de la struct
	rs	gfx_deca_x,1			; Deca X from the beginnig
	rs	gfx_flag,1			; Flag ( Flip_H : bit 1, Flip_V : bit 2)
	END_STRUCT	gfx_struct_size



; ***********************************************************************
; *									*
; *		Macros definissant les tableaux d'images		*
; *									*
; ***********************************************************************

; NEW_GFX Gfx_table
NEW_GFX	MACRO
GRAPH_INDEX_TABLE	SET	\1-0
GRAPH_COMPTEUR		SET	0
	ENDM

; ADD_GFX Gfx_label,Gfx_deca_x,flag
ADD_GFX	MACRO
GRAPH_COMPTEUR		SET	GRAPH_COMPTEUR+1
\@lab	dc.w	\1-\@lab ;GRAPH_INDEX_TABLE
	dc.b	\2
	dc.b	\3
	ENDM

; NEW_ANI	Name_of_animation
NEW_ANI	MACRO
\1		set	GRAPH_COMPTEUR
ANI_COMPTEUR	set	\1	
	ENDM

; END_ANI
END_ANI	MACRO
\1		set	(GRAPH_COMPTEUR-ANI_COMPTEUR)
	ENDM



; ***********************************************************************
; *									*
; *		Macros definissant les tableaux d'animations		*
; *									*
; ***********************************************************************

; ADD_ANI	Original_image,Nbr_rep,Nbr_image
ADD_RANI	MACRO
	dc.b	\1
	dc.b	\2
	dc.b	\3
		ENDM

ADD_SANI	MACRO
	dc.b	\1
	dc.b	\2
	dc.b	\3
		ENDM


; ***********************************************************************
; *									*
; *		Definitions des donnes du module 'graphique'		*
; *									*
; ***********************************************************************

	NEW_DATA
	rs	Gfx1_adr,4			; Adress of the tiles (gfx) of the plane A
	rs	Gfx2_adr,4			; Adress of the tiles (gfx) of the plane B

	rs	Anim_tile_adr,4			; Adress of the animation-tiles table (?)

	rs	Screen_1,4			; Adress of the 1st DScreen
	rs	Screen_2,4			; Adress of the 2nd DScreen
	rs	Select_s,2			; Current DScreen
	rs	Current_dscreen,4		; Adress of the current DScreen for some internal functions

	rs	Plan_A_adr,4			; Adress of the plane A
	rs	Dhz_A_table,4			; Adress of the dhz table of the plane A
	rs	Hdz_A_table,4			; Adress of the Hdz table of the plane A
	rs	Plan_B_adr,4			; Adress of the plane B
	rs	Dhz_B_table,4			; Adress of the dhz table of the plane B
	rs	Hdz_B_table,4			; Adress of the Hdz table of the plane B
	
	rs	Center_x,2			; From player position, correction to get the position of the scrolling : X
	rs	Center_y,2			; Same but Y

	rs	xmin,2				; Minimun positon of the scrolling
	rs	xmax,2				; Maximun position of the scrolling
	rs	ymin,2				; minimun position of the scrolling
	rs	ymax,2				; Maximun postion of the scrolling

	rs	Calc_B,1			; Flag : Calculate the coordinate of plane B ?
	rs	Diff_y,1			; Difference between Plane_A and plane_B for y position = Int(ln(SyA/SyB)/ln(2))

	rs	Print_way,2			; The way of drawing (0, 2, 4)
	rs	Update_plan,4			; Adress of the update function
		
	rs	key,4				; Genlib Joypad
	rs	key_mask,4			; Joppad's mask
						; Tableau des animations classes
	rs	CAni_table,cani_struct_size*MAX_CANI
	rs	CAni_nbr,2			; Nombre d'animation
	rs	Free_buffer,(2+4*MAX_SPRITE_SIZE*MAX_SPRITE_SIZE/16)
						; Free buffer for put_big_sprite

