; Module du gestionnaire de script
; 

; Debuggage
; Unite arit & logique : ok (Manque : lsl/lsr/neg)
; Unite calcul reel : Ok
; Unite graphisme : dline / dcircle  ...
; Unite gestion personnage : getxy
; Unite gestion niveau : rien du tout !
; Unite gestion plan : rien du tout !

; A faire
; Affichage de boite de texte temporaire
; Debugguer le reste
; Charger carte en mode global...


; Inialise un event_script sprite
; Call:
;	a1 -> Code en mode local
;	a4 -> Sct_r0 original
;	d3 = Local flag
init_script:
	tst.b	d3
	beq.s	\local
		move.l	Story_pc(a6),a1
\local:
	lea	sct_sp(a5),a0
	move.l	a0,sct_sp(a5)		; Reset stack
	move.l	a1,sct_Pc(a5)
	lea	sct_r0(a5),a0
	moveq	#16/2+1-1,d0
\loop:		move.l	(a4)+,(a0)+
		dbf	d0,\loop
	move.b	d3,sct_local(a5)
	clr.b	sct_condition(a5)
	clr.l	sct_exeption(a5)
	st.b	sct_coord(a5)
	rts

; Read long word
; In :
;	a2 -> Story code
; Out:
;	a2 += 4
;	d0.l = Current word (Like : move.l (a2)+,d0 but a2 could be unaligned)
; Destroy: 
;	a2/d0
read_long:
	bsr.s	read_word
	swap	d0

; Read word
; In :
;	a2 -> Story code
; Out:
;	a2 += 2
;	d0.w = Current word (Like : move.w (a2)+,d0 but a2 could be unaligned)
; Destroy: 
;	a2/d0
read_word:
	move.b	(a2)+,d0
	lsl.w	#8,d0
	move.b	(a2)+,d0
	rts


; Dereference l'appel aux registres r
; In :
;	a2 -> Code courant
; Out :
;	d0.w = R * 2
;	d1.w = R * 2
;	a0 -> Story_r0
; Destroy:
;	d0-d1/a0
calculate_r:
	clr.w	d0
	move.b	(a2)+,d0
	move.b	d0,d1
	andi.w	#$000F,d1
	lsr.w	#4,d0
	add.w	d0,d0
	add.w	d1,d1
	rts

; Dereference l'appel aux registres r
; In :
;	a2 -> Code courant
; Out :
;	d0.w = R * 4
;	d1.w = R * 4
;	a0 -> Story_r0
; Destroy:
;	d0-d1/a0
calculate_f:
	bsr.s	calculate_r
	andi.w	#%110,d0
	andi.w	#%110,d1
	add.w	d0,d0
	add.w	d1,d1
	rts


; Execute le code associe a un evenement (global ou local).
; La difference entre global et local est simple :
; * Un local arrive tout le temps car il n'est pas memorise pour eviter ce probleme.
; * On ne peut pas tester qu'un local a eu lieu.
; * Un local n'a pas le droit de changer de carte ! (Sinon erreur !)
; Normalement aucun autre module autre que 'game' ne peut appeler cette routine
; en mode global
; Exemple :
;	Local story  : give a2 & d0.b = -1
;	Global story : d0.b = 0
exec_script:
	move.l	(a3)+,a5

	move.l	sct_Pc(a5),a2
	clr.b	sct_update(a5)

	; Test la condition de retour...
	move.b	sct_condition(a5),d0
	beq.s	Sct_loop
		subq.b	#1,d0
		bne.s	\no_wait
			subq.b	#1,sct_flag(a5)
			bne.s	_sct_end_loop
			bra.s	\done
\no_wait:	subq.b	#1,d0
		bne.s	\done
			; Recherche s'il reste des persos de type 'TYPE_move'
			move.l	Spr_print_adr(a6),a0
			move.w	Spr_level(a6),d0
\loop:			cmp.b	#TYPE_move,Type(a0,d0.w)
			beq.s	_sct_end_loop
			adda.w	Size(a0),a0
			cmp.l	Spr_print_end_adr(a6),a0
			bmi.s	\loop
\done:	clr.b	sct_condition(a5)
	
	; Boucle d'emulation
Sct_loop:	
		moveq	#0,d0
		move.b	(a2)+,d0
		cmpi.b	#91,d0
		bhi	error::illegal_story
		add.w	d0,d0
		move.w	Event_code_table(Pc,d0.w),d0
		jmp	Event_code_table(Pc,d0.w)

_sct_end_loop:
	; Sauvegarde la valeur du Pc
	move.l	a2,sct_Pc(a5)

	; Verifie s'il faut mettre a jour le linkage des sprites...
	tst.b	sct_update(a5)
	beq.s	\no_update
		bsr	sprite::generate
		bsr	sprite::calculate
\no_update:
	move.l	(a3)+,a0
	jmp	(a0)


Event_code_table:
	dc.w	_sct_fin-Event_code_table		; 0

	dc.w	_sct_mov-Event_code_table		; 1
	dc.w	_sct_movi-Event_code_table		; 2
	dc.w	_sct_load-Event_code_table		; 3
	dc.w	_sct_read-Event_code_table		; 4
	dc.w	_sct_write-Event_code_table		; 5
	dc.w	_sct_add-Event_code_table		; 6
	dc.w	_sct_addi-Event_code_table		; 7
	dc.w	_sct_sub-Event_code_table		; 8
	dc.w	_sct_subi-Event_code_table		; 9
	dc.w	_sct_and-Event_code_table		; 10
	dc.w	_sct_andi-Event_code_table		; 11
	dc.w	_sct_or-Event_code_table		; 12
	dc.w	_sct_ori-Event_code_table		; 13
	dc.w	_sct_xor-Event_code_table		; 14
	dc.w	_sct_xori-Event_code_table		; 15

	dc.w	_sct_je-Event_code_table		; 16
	dc.w	_sct_jne-Event_code_table		; 17
	dc.w	_sct_jump-Event_code_table		; 18
	dc.w	_sct_call-Event_code_table		; 19
	dc.w	_sct_ret-Event_code_table		; 20

	dc.w	_sct_testobj-Event_code_table		; 21
	dc.w	_sct_teststo-Event_code_table		; 22

	dc.w	_sct_newp-Event_code_table		; 23
	dc.w	_sct_news-Event_code_table		; 24
	dc.w	_sct_movpvar-Event_code_table		; 25
	dc.w	_sct_movpxy-Event_code_table		; 26
	dc.w	_sct_movppos-Event_code_table		; 27
	dc.w	_sct_setani-Event_code_table		; 28

	dc.w	_sct_wait-Event_code_table		; 29
	dc.w	_sct_display-Event_code_table		; 30
	dc.w	_sct_loadmap-Event_code_table		; 31
	dc.w	_sct_dialog-Event_code_table		; 32

	dc.w	_sct_remove-Event_code_table		; 33

	dc.w	_sct_giveobj-Event_code_table		; 34
	dc.w	_sct_givesto-Event_code_table		; 35

	dc.w	_sct_getkey-Event_code_table		; 36
	dc.w	_sct_setdiag-Event_code_table		; 37
	dc.w	_sct_setcoord-Event_code_table		; 38
	dc.w	_sct_scroll-Event_code_table		; 39

	dc.w	_sct_getxy-Event_code_table		; 40
	dc.w	_sct_deref-Event_code_table		; 41
	dc.w	_sct_view-Event_code_table		; 42

	dc.w	_sct_readp-Event_code_table		; 43
	dc.w	_sct_writep-Event_code_table		; 44
	dc.w	_sct_readm-Event_code_table		; 45
	dc.w	_sct_writem-Event_code_table		; 46

	dc.w	_sct_putspr-Event_code_table		; 47
	dc.w	_sct_dline-Event_code_table		; 48
	dc.w	_sct_dcircle-Event_code_table		; 49
	dc.w	_sct_dtriangle-Event_code_table		; 50

	dc.w	_sct_call68k-Event_code_table		; 51
	dc.w	_sct_func-Event_code_table		; 52

	dc.w	_sct_cmp-Event_code_table		; 53
	dc.w	_sct_cmpi-Event_code_table		; 54

	dc.w	_sct_newscript-Event_code_table		; 55
	dc.w	_sct_readkey-Event_code_table		; 56
	dc.w	_sct_newtype-Event_code_table		; 57
	dc.w	_sct_exeption-Event_code_table		; 58

	dc.w	_sct_heightR-Event_code_table		; 59
	dc.w	_sct_heightW-Event_code_table		; 60
	dc.w	_sct_GraphR-Event_code_table		; 61
	dc.w	_sct_GraphW-Event_code_table		; 62
	dc.w	_sct_ItemR-Event_code_table		; 63
	dc.w	_sct_ItemW-Event_code_table		; 64

	dc.w	_sct_savemode-Event_code_table		; 65
	dc.w	_sct_loadmode-Event_code_table		; 66
	dc.w	_sct_loadpb-Event_code_table		; 67
	dc.w	_sct_scrollpb-Event_code_table		; 68
	dc.w	_sct_setmode-Event_code_table		; 69
	dc.w	_sct_loaddhzpb-Event_code_table		; 70
	dc.w	_sct_loaddhzpa-Event_code_table		; 71

	dc.w	_sct_declum-Event_code_table		; 72
	dc.w	_sct_inclum-Event_code_table		; 73

	dc.w	_sct_fltmovi-Event_code_table		; 74
	dc.w	_sct_fltint-Event_code_table		; 75
	dc.w	_sct_fltint2-Event_code_table		; 76
	dc.w	_sct_fltadd-Event_code_table		; 77
	dc.w	_sct_fltsub-Event_code_table		; 78
	dc.w	_sct_fltmul-Event_code_table		; 79
	dc.w	_sct_fltdiv-Event_code_table		; 80
	dc.w	_sct_fltcos-Event_code_table		; 81
	dc.w	_sct_fltsin-Event_code_table		; 82
	dc.w	_sct_fltmov-Event_code_table		; 83
	dc.w	_sct_fltload-Event_code_table		; 84
	dc.w	_sct_fltsave-Event_code_table		; 85
	dc.w	_sct_fltcmp-Event_code_table		; 86
	dc.w	_sct_fltset-Event_code_table		; 87
	
	dc.w	_sct_stop-Event_code_table		; 88
	dc.w	_sct_jg-Event_code_table		; 89
	dc.w	_sct_jl-Event_code_table		; 90
	dc.w	_sct_message-Event_code_table		; 91

; In :
;	a2 -> Current code
; Out :
;	a2 updated
; Can't change :
;	d7/a3-a7
; Return at Sct_loop

_sct_fin:
	; Verifie s'il faut mettre a jour le linkage des sprites...
	tst.b	sct_update(a5)
	beq.s	\no_update
		bsr	sprite::generate
		bsr	sprite::calculate
\no_update:
	; Teste s'il faut mettre a zero le pointeur global
	tst.b	sct_local(a5)
	beq.s	\local
		clr.l	Story_pc(a6)	; Pour eviter des problemes :)
\local:
	bra	sprite::next
	



; Classique...
_sct_mov:
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),sct_r0(a5,d1.w)
	bra	Sct_loop

_sct_movi:
	bsr	read_word
	move.b	(a2)+,d1
	andi.w	#$000F,d1
	add.w	d1,d1
	move.w	d0,sct_r0(a5,d1.w)
	bra	Sct_loop
	
_sct_load:
	bsr	read_word
	lea	-2(a2,d0.w),a0
	move.l	a0,sct_ptr(a5)
	bra	Sct_loop

_sct_read:
	move.l	sct_ptr(a5),a1
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	add.w	d0,d0
	move.w	0(a1,d0.w),sct_r0(a5,d1.w)
	bra	Sct_loop
		
_sct_write:
	move.l	sct_ptr(a5),a1
	bsr	calculate_r
	move.w	sct_r0(a5,d1.w),d1
	add.w	d1,d1
	move.w	sct_r0(a5,d0.w),0(a1,d1.w)
	bra	Sct_loop

_sct_readp:
	move.l	sct_ptr(a5),a1
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d2
	add.w	d2,d2
	move.w	0(a1,d2.w),sct_r0(a5,d1.w)
	lsr.w	#1,d2
	addq.w	#1,d2
	move.w	d2,sct_r0(a5,d0.w)
	bra	Sct_loop
		
_sct_writep:
	move.l	sct_ptr(a5),a1
	bsr	calculate_r
	move.w	sct_r0(a5,d1.w),d2
	add.w	d2,d2
	move.w	sct_r0(a5,d0.w),0(a1,d2.w)
	lsr.w	#1,d2
	addq.w	#1,d2
	move.w	d2,sct_r0(a5,d1.w)
	bra	Sct_loop

_sct_readm:
	move.l	sct_ptr(a5),a1
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d2
	subq.w	#1,d2
	move.w	d2,sct_r0(a5,d0.w)
	add.w	d2,d2
	move.w	0(a1,d2.w),sct_r0(a5,d1.w)
	bra	Sct_loop
		
_sct_writem:
	move.l	sct_ptr(a5),a1
	bsr	calculate_r
	move.w	sct_r0(a5,d1.w),d2
	subq.w	#1,d2
	move.w	d2,sct_r0(a5,d1.w)
	add.w	d2,d2
	move.w	sct_r0(a5,d0.w),0(a1,d2.w)
	bra	Sct_loop




_sct_add:
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	add.w	d0,sct_r0(a5,d1.w)
	bra	Sct_loop

_sct_addi:
	bsr	read_word
	move.b	(a2)+,d1
	andi.w	#$000F,d1
	add.w	d1,d1
	add.w	d0,sct_r0(a5,d1.w)
	bra	Sct_loop

_sct_sub:
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	sub.w	d0,sct_r0(a5,d1.w)
	bra	Sct_loop

_sct_subi:
	bsr	read_word
	move.b	(a2)+,d1
	andi.w	#$000F,d1
	add.w	d1,d1
	sub.w	d0,sct_r0(a5,d1.w)
	bra	Sct_loop

_sct_cmp:
	bsr	calculate_r
	move.w	sct_r0(a5,d1.w),d1
	cmp.w	sct_r0(a5,d0.w),d1
	beq.s	\zero
		bgt.s	\pos
			st.b	d1
			bra.s	\done
\pos:		moveq	#1,d1
		bra.s	\done
\zero:	clr.b	d1
\done:	move.b	d1,sct_flag(a5)
	bra	Sct_loop

_sct_cmpi:
	bsr	read_word
	move.b	(a2)+,d1
	andi.w	#$000F,d1
	add.w	d1,d1
	cmp.w	sct_r0(a5,d1.w),d0
	beq.s	\zero
		blt.s	\pos
			st.b	d1
			bra.s	\done
\pos:		moveq	#1,d1
		bra.s	\done
\zero:	clr.b	d1
\done:	move.b	d1,sct_flag(a5)
	bra	Sct_loop

_sct_and:
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	and.w	d0,sct_r0(a5,d1.w)
	bra	Sct_loop

_sct_andi:
	bsr	read_word
	move.b	(a2)+,d1
	andi.w	#$000F,d1
	add.w	d1,d1
	and.w	d0,sct_r0(a5,d1.w)
	bra	Sct_loop

_sct_or:
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	or.w	d0,sct_r0(a5,d1.w)
	bra	Sct_loop

_sct_ori:
	bsr	read_word
	move.b	(a2)+,d1
	andi.w	#$000F,d1
	add.w	d1,d1
	or.w	d0,sct_r0(a5,d1.w)
	bra	Sct_loop

_sct_xor:
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	eor.w	d0,sct_r0(a5,d1.w)
	bra	Sct_loop

_sct_xori:
	bsr	read_word
	move.b	(a2)+,d1
	andi.w	#$000F,d1
	add.w	d1,d1
	eor.w	d0,sct_r0(a5,d1.w)
	bra	Sct_loop



_sct_je:
	bsr	read_word
	tst.b	sct_flag(a5)
	bne.s	\ret
		subq.w	#2,d0
		adda.w	d0,a2
\ret:	bra	Sct_loop


_sct_jne:
	bsr	read_word
	tst.b	sct_flag(a5)
	beq.s	\ret
		subq.w	#2,d0
		adda.w	d0,a2
\ret:	bra	Sct_loop

_sct_jg:
	bsr	read_word
	tst.b	sct_flag(a5)
	ble.s	\ret
		subq.w	#2,d0
		adda.w	d0,a2
\ret:	bra	Sct_loop
	

_sct_jl:
	bsr	read_word
	tst.b	sct_flag(a5)
	bge.s	\ret
		subq.w	#2,d0
		adda.w	d0,a2
\ret:	bra	Sct_loop

_sct_jump
	bsr	read_word
	subq.w	#2,d0
	adda.w	d0,a2
	bra	Sct_loop

_sct_call:
	bsr	read_word
	move.l	sct_sp(a5),a0
	move.l	a2,-(a0)		; Save adress !
	move.l	a0,sct_sp(a5)
	subq.w	#2,d0
	adda.w	d0,a2
	bra	Sct_loop
	
_sct_ret:
	move.l	sct_sp(a5),a0
	move.l	(a0)+,a2		; Save adress !
	move.l	a0,sct_sp(a5)
	bra	Sct_loop
	


_sct_testobj
	bsr	read_word
	bsr	object::is
	move.b	d2,sct_flag(a5)
	bra	Sct_loop

_sct_teststo
	bsr	read_word
	bsr	event::is
	move.b	d2,sct_flag(a5)
	bra	Sct_loop








; Nouveau personnage
_sct_newp:
	moveq	#0,d2
	move.b	(a2)+,d2	; Item_sprite
	add.w	d2,d2		; Index in Item_to_sprite_table
	lea	Item_to_sprite_table(Pc),a0
	adda.w	d2,a0
	move.w	0(a0),d2	; D2.w = No du sprite

	bsr	read_word
	move.w	d0,d3		; D3 = No du perso

	clr.w	d4
	move.b	(a2)+,d4	; D4 = Level

	bsr	read_word
	lea	-2(a2,d0.w),a4	; A4 -> Dialog struct

	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0	; D0.W = X position
	move.w	sct_r0(a5,d1.w),d1	; d1.w = Y position
	bsr	transform_glo
	bsr	sprite::add

	st	sct_update(a5)
	bra	Sct_loop

; Nouveau sprite
_sct_news
	bsr	read_word
	move.w	d0,d2		; d2.W = Type du sprite

	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0	; D0.W = X position
	move.w	sct_r0(a5,d1.w),d1	; d1.w = Y position
	bsr	transform_glo

	bsr	sprite::add

	st	sct_update(a5)
	bra	Sct_loop


; Fixe tout pour faire deplacer le personnage (sauf la destination !)
_sct_move_player:
	; Dereference le personnage...
	bsr	read_word	; d0.w = Player
	move.b	(a2)+,d1	; d1.b = Nbr
_sct_move_player2
	bsr	player::deref_2_stack
	tst.b	d0		; A0 = Sprite Player ?
	beq	error_cant_sp

	; Fixe le type...
	move.w	Spr_level(a6),d0
	move.b	#TYPE_move,Type(a0,d0.w)

	; Fixe l'animation
	moveq	#ANI_WALK,d5
	exg	a0,a5
	bsr	player::animation
	exg	a0,a5

	st	sct_update(a5)
	rts

; Si on a une exeption, on y va sinon, erreur !
error_cant_sp:
	addq.l	#4,a7
error_cant:
	move.l	sct_exeption(a5),d0
	beq	error::cant_find_player
	move.l	d0,a2
	bra	Sct_loop

; Deplace le personnage a l'aide des variables
_sct_movpvar:
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	move.w	sct_r0(a5,d1.w),d1
	bsr	_sct_move_player2

	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	move.w	sct_r0(a5,d1.w),d1
	bsr	transform_glo
	move.w	d0,Xd(a0)
	move.w	d1,Yd(a0)
	bra	Sct_loop
	
; Deplace le personnage relativement
_sct_movpxy:
	bsr	_sct_move_player

	move.b	(a2)+,d0
	ext.w	d0
	move.w	X(a0),d2
	add.w	d0,d2
	move.w	d2,Xd(a0)

	move.b	(a2)+,d1
	ext.w	d1
	move.w	Y(a0),d2
	add.w	d1,d2	
	move.w	d2,Yd(a0)
	bra	Sct_loop

; Deplace le personnage a une position
_sct_movppos:
	bsr	_sct_move_player
	move.l	a0,a1

	bsr	read_word
	move.w	d0,d2
	bsr	position::deref
	move.w	d0,Xd(a1)
	move.w	d1,Yd(a1)
	bra	Sct_loop


; Fixe l'animation du personnage
_sct_setani
	bsr	read_word
	move.b	(a2)+,d1
	bsr	player::deref_2_stack
	tst.b	d0
	beq	error_cant

	moveq	#0,d5
	move.b	(a2)+,d5	; D5 = Ani.w
	cmp.b	#-1,d5
	beq.s	\no_ani
		exg	a0,a5
		bsr	player::animation
		exg	a0,a5
\no_ani:
	move.b	(a2)+,d5
	cmp.b	#-1,d5
	beq.s	\no_sens
		move.b	d5,Sens(a0)
\no_sens:
	bra	Sct_loop



; Attend x frames avant de reprendre
_sct_wait:
	move.b	(a2)+,sct_flag(a5)
	move.b	#1,sct_condition(a5)
	bra	_sct_end_loop

; Attend que tout le monde est atteint son but
_sct_display:
	move.b	#2,sct_condition(a5)
	bra	_sct_end_loop


; Charge une carte
_sct_loadmap
	move.l	a2,a1
	addq.l	#8,a2

	pea	\return(Pc)
	bsr	Item_map		;(a2 -> Map 6 + x.b + y.b)
\return:
	tst.b	sct_local(a5)
	beq	\local
		move.l	a2,Story_pc(a6)
\local:	rts			; Quitte le linkage et charge la carte...

; Demarre un dialogue...
_sct_dialog
	move.l	a2,a0
	bsr	dialog::do
	; Recherche la fin de la structure de dialogue.
\next:		cmp.b	#EndDialog,(a2)+
		bne.s	\next
	bra	Sct_loop

; Enleve un personnage de la pile !
_sct_remove
	; Attention a ne pas enlever un personnage de base !!
	; Ce n'est pas encore pret !
	bsr	read_word
	move.b	(a2)+,d1
	bsr	player::deref_2_stack
	tst.b	d0
	beq	error_cant
	
	; Destruction
	bsr	sprite::destruct
	st	sct_update(a5)

	bra	Sct_loop



; Donne un objet
_sct_giveobj:
	bsr	read_word
	bsr	object::add
	bra	Sct_loop

_sct_givesto:
	bsr	read_word
	bsr	event::give
	bsr	sprite::calculate
	bra	Sct_loop



; Lit une touche et attend au clavier
_sct_getkey:
	bsr	GetKey
	move.b	(a2)+,d1
	and.w	#$000F,d1
	add.w	d1,d1
	move.w	d0,sct_r0(a5,d1.w)
	bra	Sct_loop

; Fixe le dialogue d'un personnage...
_sct_setdiag:
	bsr	read_word
	move.b	(a2)+,d1
	bsr	player::deref_2_stack
	tst.b	d0
	beq	error_cant

	bsr	read_word
	lea	-2(a2,d0.w),a1
	move.l	a1,Diag_adr(a0)
	bra	Sct_loop

; Fixe les coordonnes du plan A
_sct_scroll:
	bsr	calculate_r
	move.l	Plan_A_adr(a6),a1
	move.w	sct_r0(a5,d0.w),d0
	move.w	sct_r0(a5,d1.w),d1
	bsr	transform_glo
	move.w	d0,PLANE_XS(a1)
	move.w	d1,PLANE_YS(a1)
	bra	Sct_loop

; Donne les coordonnes x,y d'un personnage
_sct_getxy:
	bsr	read_word
	move.b	(a2)+,d1
	bsr	player::deref_2_stack
	tst.b	d0
	beq	error_cant

	move.w	X(a0),d0
	move.w	Y(a0),d1
	bsr	glo_courant
	move.w	d0,d2
	move.w	d1,d3
	bsr	calculate_r
	move.w	d2,sct_r0(a5,d0.w)
	move.w	d3,sct_r0(a5,d1.w)
	bra	Sct_loop

; Derefence une position en ces coordonnes
_sct_deref:
	bsr	read_word
	move.w	d0,d2
	bsr	calculate_r
	pea	sct_r0(a5,d0.w)
	pea	sct_r0(a5,d1.w)
	bsr	position::deref
	bsr	glo_courant
	move.l	(a7)+,a0
	move.w	d0,(a0)
	move.l	(a7)+,a0
	move.w	d1,(a0)
	bra	Sct_loop

; Pointe un pesonnage en direction d'un autre
_sct_view:
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	move.w	sct_r0(a5,d1.w),d1
	bsr	player::deref_2_stack
	tst.b	d0
	beq	error_cant
	move.l	a0,a1

	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	move.w	sct_r0(a5,d1.w),d1
	bsr	player::deref_2_stack
	tst.b	d0
	beq	error_cant

	move.w	X(a1),d0
	move.w	Y(a1),d1
	sub.w	X(a0),d0			; X-X_dest
	sub.w	Y(a0),d1			; Y-Y_dest
	bsr	player::calc_sens
	move.b	d2,Sens(a1)
	bra	Sct_loop

; Affiche un sprite a l'ecran en var,var
_sct_putspr:
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d2
	move.w	sct_r0(a5,d1.w),d1
	bsr	read_word
	lea	-2(a2,d0.w),a0
	move.w	d2,d0
	bsr	transform_glo
	jsr	genlib::put_big_sprite
	bra	Sct_loop

; Affiche une ligne
_sct_dline:
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	move.w	sct_r0(a5,d1.w),d1
	bsr	transform_rel
	move.w	d0,d2
	move.w	d1,d3
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	move.w	sct_r0(a5,d1.w),d1
	bsr	transform_rel
	clr.w	d5
	move.b	(a2)+,d5
	add.w	d5,d5
	move.w	sct_r0(a5,d5.w),d5
	jsr	genlib::draw_clipped_line
	bra	Sct_loop

; Affiche un cercle !
_sct_dcircle:
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	move.w	sct_r0(a5,d1.w),d1
	bsr	transform_rel
	move.w	d0,d4
	move.w	d1,d5
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d2
	move.w	sct_r0(a5,d1.w),d3
	jsr	genlib::draw_clipped_circle	
	bra	Sct_loop

; Affiche un triangle !
_sct_dtriangle:
	bsr	calculate_r
	lea	sct_r0(a5,d0.w),a1
	lea	sct_r0(a5,d1.w),a2
		move.w	(a1)+,d0
		move.w	(a1)+,d1
		bsr	transform_rel
		move.w	d1,-(a1)
		move.w	d0,-(a1)
		move.w	(a2)+,d0
		move.w	(a2)+,d1
		bsr	transform_rel
		move.w	d1,-(a2)
		move.w	d0,-(a2)
	bsr	calculate_r
	lea	sct_r0(a5,d0.w),a0
		move.w	(a0)+,d0
		move.w	(a0)+,d1
		bsr	transform_rel
		move.w	d1,-(a0)
		move.w	d0,-(a0)
	move.w	sct_r0(a5,d1.w),d0
	exg	a0,a3
	jsr	genlib::draw_clipped_c_face
	exg	a0,a3
	bra	Sct_loop


; Fait appel a une routine a68k inline !
_sct_call68k
	bsr	read_word
	lea	-2(a2,d0.w),a0
	movem.l	d6-d7/a2-a6,-(a7)
	jsr	(a0)
	movem.l	(a7)+,d6-d7/a2-a6
	bra	Sct_loop

; Fait appel a une fonction...
_sct_func
	movem.l	d6-d7/a2-a6,-(a7)
	bsr	read_word	; Lecture du numero de la fonction
	move.w	d0,-(a7)
	bsr	read_word
	move.w	d0,d1
	move.w	d0,d3		; D0 = D1 = D3 // Ok pas terrible
	bsr	function::call
	addq.l	#2,a7
	movem.l	(a7)+,d6-d7/a2-a6
	move.w	d2,sct_r0(a5)
	move.b	d2,sct_flag(a5)
	addq.l	#4,a2
	bra	Sct_loop


; Lance un nouveau script
_sct_newscript
	bsr	read_word
	clr.b	d3
	lea	-2(a2,d0.w),a1
	lea	sct_r0(a5),a4
	moveq	#SPR_script,d2
	bsr	sprite::add
	st	sct_update(a5)
	bra	Sct_loop

; Lecture des touches sans attendre
_sct_readkey
	jsr	genlib::read_joypad
	move.b	(a2)+,d1
	and.w	#%1111,d1
	add.w	d1,d1
	move.w	d0,sct_r0(a5,d1.w)
	bra	Sct_loop

; Changement de type...
_sct_newtype
	move.w	Spr_level(a6),d0
	move.b	(a2)+,d1
	move.b	(a2)+,d2
	move.l	Sprite_adr(a6),a0
\loop1		cmp.b	Type(a0,d0.w),d1
		bne.s	\next1
			move.b	d2,Type(a0,d0.w)
\next1		adda.w	Size(a0),a0
		cmp.l	Sprite_end_adr(a6),a0
		bmi.s	\loop1
	move.l	Spr_print_adr(a6),a0
\loop2		cmp.b	Type(a0,d0.w),d1
		bne.s	\next2
			move.b	d2,Type(a0,d0.w)
\next2		adda.w	Size(a0),a0
		cmp.l	Spr_print_end_adr(a6),a0
		bmi.s	\loop2
	; Utile si on enleve le gestionnaire de touches :)
	moveq	#-1,d0
	move.l	d0,key(a6)
	st	sct_update(a5)
	bra	Sct_loop

; Determine la routine d'exeption...
_sct_exeption
	bsr	read_word
	suba.l	a0,a0
	tst.w	d0
	beq.s	\no
		lea	-2(a2,d0.W),a0
\no	move.l	a0,sct_exeption(a5)
	bra	Sct_loop


; LEcture/Ecriture au table courante
_sct_heightR
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	move.w	sct_r0(a5,d1.w),d1
	bsr	transform_glo
	lsr.w	#4,d0
	lsr.w	#4,d1
	lsl.w	d7,d1
	add.w	d0,d1
	move.l	Height_tab(a6),a0
	move.b	0(a0,d1.w),d2
	and.w	#%0111,d2
	move.b	(a2)+,d0
	and.w	#%01111,d0
	add.w	d0,d0
	move.w	d2,sct_r0(a5,d0.w)
	bra	Sct_loop

_sct_heightW
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	move.w	sct_r0(a5,d1.w),d1
	bsr	transform_glo
	lsr.w	#4,d0
	lsr.w	#4,d1
	lsl.w	d7,d1
	add.w	d0,d1
	move.l	Height_tab(a6),a0
	move.b	0(a0,d1.w),d2
	and.w	#%011111000,d2
	move.b	(a2)+,d0
	and.w	#%0111,d0
	or.w	d2,d0
	move.b	d0,0(a0,d1.w)
	bra	Sct_loop

_sct_GraphR
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	move.w	sct_r0(a5,d1.w),d1
	bsr	transform_glo
	lsr.w	#4,d0
	lsr.w	#4,d1
	lsl.w	d7,d1
	add.w	d0,d1
	move.l	Graph_adr(a6),a0
	clr.w	d2
	move.b	0(a0,d1.w),d2
	move.b	(a2)+,d0
	and.w	#%01111,d0
	add.w	d0,d0
	move.w	d2,sct_r0(a5,d0.w)
	bra	Sct_loop

_sct_GraphW
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	move.w	sct_r0(a5,d1.w),d1
	bsr	transform_glo
	lsr.w	#4,d0
	lsr.w	#4,d1
	lsl.w	d7,d1
	add.w	d0,d1
	move.l	Graph_adr(a6),a0
	move.b	(a2)+,0(a0,d1.w)
	bra	Sct_loop

_sct_ItemR
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	move.w	sct_r0(a5,d1.w),d1
	bsr	transform_glo
	lsr.w	#4,d0
	lsr.w	#4,d1
	lsl.w	d7,d1
	add.w	d0,d1
	move.l	Height_tab(a6),a0
	clr.w	d2
	move.b	0(a0,d1.w),d2
	lsr.w	#3,d2
	move.b	(a2)+,d0
	and.w	#%01111,d0
	add.w	d0,d0
	move.w	d2,sct_r0(a5,d0.w)
	bra	Sct_loop

_sct_ItemW
	bsr	calculate_r
	move.w	sct_r0(a5,d0.w),d0
	move.w	sct_r0(a5,d1.w),d1
	bsr	transform_glo
	lsr.w	#4,d0
	lsr.w	#4,d1
	lsl.w	d7,d1
	add.w	d0,d1
	move.l	Height_tab(a6),a0
	move.b	0(a0,d1.w),d2
	and.w	#%0111,d2
	move.b	(a2)+,d0
	lsl.w	#3,d0
	and.w	#%011111100,d0
	or.w	d2,d0
	move.b	d0,0(a0,d1.w)
	bra	Sct_loop

_sct_savemode
_sct_loadmode
_sct_loadpb
_sct_scrollpb
_sct_loaddhzpb
_sct_loaddhzpa

_sct_setmode
	move.b	(a2)+,d0
	bsr	print::mode
	bra	Sct_loop

; Changement de luminosite !
_sct_declum
	moveq	#10,d0	; 10=contrast_down
	trap	#9
	jsr	(a0)
	bra	Sct_loop

_sct_inclum
	moveq	#09,d0	; 9=contrast_up
	trap	#9	; trap
	jsr	(a0)	; call rom
	bra	Sct_loop


; Floatting routines
; Chargement (ex: 1,2,f0 => f0=1/2
_sct_fltmovi
	bsr	read_long
	move.b	(a2)+,d1
	andi.w	#%011,d1
	lsl.w	#2,d1
	move.l	d0,sct_f0(a5,d1.w)
	bra	Sct_loop

; Entier to float
_sct_fltint	
	bsr	calculate_r
	add.w	d1,d1
	move.w	sct_r0(a5,d0.w),sct_f0(a5,d1.w)
	clr.w	sct_f0+2(a5,d1.w)
	bra	Sct_loop
	
; Float to int
_sct_fltint2
	bsr	calculate_r
	add.w	d0,d0
	move.w	sct_f0(a5,d0.w),sct_r0(a5,d1.w)
	bra	Sct_loop

_sct_fltadd	
	bsr	calculate_f
	move.l	sct_f0(a5,d0.w),d0
	add.l	d0,sct_f0(a5,d1.w)
	bra	Sct_loop

_sct_fltsub	
	bsr	calculate_f
	move.l	sct_f0(a5,d0.w),d0
	sub.l	d0,sct_f0(a5,d1.w)
	bra	Sct_loop

_sct_fltmul
	bsr	calculate_f
	move.l	sct_f0(a5,d0.w),d0
	lea	sct_f0(a5,d1.w),a0
	move.l	(a0),d1
	fmuls	d0,d1
	move.l	d1,(a0)
	bra	Sct_loop

_sct_fltdiv	
	bsr	calculate_f
	move.l	sct_f0(a5,d0.w),d0
	lea	sct_f0(a5,d1.w),a0
	move.l	(a0),d1
	fdivs	d0,d1,d3,d4
	move.l	d1,(a0)
	bra	Sct_loop

_sct_fltcos	
	lea	genlib::cos,a0
_sct_flt_calc:
	bsr	calculate_f
	move.b	sct_f0+1(a5,d0.w),d0
	and.l	#$00FF,d0
	move.b	0(a0,d0.w),d0		; D0.b = 128 * cos(d0.b)
	asl.l	#8,d0			; D0.l = 32k * cos(d0.b)
	add.l	d0,d0
	move.l	d0,sct_f0(a5,d1.w)
	bra	Sct_loop

_sct_fltsin	
	lea	genlib::sin,a0
	bra.s	_sct_flt_calc

_sct_fltmov
	bsr	calculate_f
	move.l	sct_f0(a5,d0.w),sct_f0(a5,d1.w)
	bra	Sct_loop

_sct_fltload:
	bsr	read_word
	move.l	-2(a2,d0.w),d0
	clr.w	d1
	move.b	(a2)+,d1
	lsl.w	#2,d1
	move.l	d0,sct_f0(a5,d1.w)
	bra	Sct_loop

_sct_fltsave:
	clr.w	d1
	move.b	(a2)+,d1
	lsl.w	#2,d1
	bsr	read_word
	move.l	sct_f0(a5,d1.w),-2(a2,d0.w)
	bra	Sct_loop

_sct_fltcmp:
	bsr	calculate_f
	move.l	sct_f0(a5,d1.w),d1
	sub.l	sct_f0(a5,d0.w),d1
	bge.s	\Ok
		neg.l	d1
\Ok:	cmp.l	sct_precision(a5),d1
	blt.s	\zero
		st.b	d1
		bra.s	\done
\zero:	clr.b	d1
\done:	move.b	d1,sct_flag(a5)
	bra	Sct_loop

_sct_fltset
	bsr	read_long
	move.l	d0,sct_precision(a5)
	bra	Sct_loop


; Transforme de relatif a global
_sct_setcoord:
	move.b	(a2)+,sct_coord(a5)
	bra	Sct_loop

; In : d0.w / d1.w en mode courant
; Out: d0.w / d1.w en mode global
transform_glo
	tst.b	sct_coord(a5)
	beq.s	\Ok
		move.l	Plan_A_adr(a6),a0
		add.w	PLANE_XS(a0),d0
		add.w	PLANE_YS(a0),d1
\Ok:	rts

; In : d0.w / d1.w en mode courant
; Out: d0.w / d1.w en mode relatif
transform_rel
	tst.b	sct_coord(a5)
	bne.s	\Ok
		move.l	Plan_A_adr(a6),a0
		sub.w	PLANE_XS(a0),d0
		sub.w	PLANE_YS(a0),d1
\Ok:	rts

; Out : d0.w / d1.w en mode courant
; In  : d0.w / d1.w en mode global
glo_courant
	tst.b	sct_coord(a5)
	beq.s	\Ok
		move.l	Plan_A_adr(a6),a0
		sub.w	PLANE_XS(a0),d0
		sub.w	PLANE_YS(a0),d1
\Ok:	rts

_sct_stop
	bra.s	_sct_stop
	bra	Sct_loop

_sct_message:
	clr.w	d3
	move.b	(a2)+,d3	; Temps
	clr.w	d4
	move.b	(a2)+,d4	; Fond
	ext.w	d4
	move.l	a2,a4
	moveq	#SPR_message,d2
	bsr	sprite::add
	st	sct_update(a5)
\wait		cmpi.b	#$FF,(a2)+
		bne.s	\wait
	bra	Sct_loop

_sct_setcar:	; (r0,r1) perso / r2: car type / r3: ou lire
_sct_getcar:	; (r0,r1) perso / r2: car type / r3: ou ecrire
_sct_attack:	; (r0,r1) perso src / (r2,r3) : perso dest / Attaque_force.w / Attaque_type.b / r8: HP_down (sortie)
_sct_waitani:	; (r0,r1) attend fin animation du perso
_sct_dnumber:	; (r0,r1) position / r2: nombre
_sct_arret:	; Arrete tous les autres scripts et quasiment tous sauf ce qui est indispensable
_sct_fight:	; La preparation est finie / On attend que cela repparte
_sct_recover:	; On se remet a reaugmenter son attente
_sct_cmppos	; Dist( (r0,r1) , (r2,r3) ) < Dist.b ?
